%define version   0.4.8
%define release   %mkrel 4

%define anthy_version      6620
%define m17n_lib_version   1.2.0

%define qtimmodule 1
%{?_with_qtimmodule: %{expand: %%global qtimmodule 1}}

%define libname_orig lib%{name}
%define libname %mklibname %{name} 0

# QTDIR is /usr/lib/qt3 for the time being
%define qtdir %{_prefix}/lib/qt3

Name:      uim
Summary:   Uim is a multilingual input method library 
Version:   %{version}
Release:   %{release}
Group:     System/Internationalization
License:   GPL or BSD
URL:       http://uim.freedesktop.org/wiki/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

# latest snapshot
# http://freedesktop.org/~tkng/uim-trunk.tar.gz
Source0:   http://freedesktop.org/~tkng/%{name}-%{version}.tar.bz2

Requires:        %{libname} = %{version}
Requires:        uim-applet
Requires:        anthy >= %{anthy_version}
Requires:        m17n-lib >= %{m17n_lib_version}
Requires:        skkdic
Prereq:          %_bindir/gtk-query-immodules-2.0
Conflicts:       gtk+2.0 < 2.4.4-2mdk
Obsoletes:       uim-anthy, uim-m17nlib, uim-prime, uim-skk
Provides:        uim-anthy, uim-m17nlib, uim-prime, uim-skk
BuildRequires:   qt3-devel >= 3.3.4-9mdk
BuildRequires:   gtk+2-devel >= 2.4.0
BuildRequires:   libgnome2-devel
BuildRequires:   gnome-panel-devel
BuildRequires:   m17n-lib-devel >= %{m17n_lib_version}
BuildRequires:   libanthy-devel >= %{anthy_version}
BuildRequires:   intltool
BuildRequires:   libncurses-devel, automake1.7

%description
Uim is a multilingual input method library. Uim's project goal is 
to provide secure and useful input method for all languages.


%package   gtk
Summary:   GNOME helper for uim
Group:     System/Internationalization
Requires:  %{name} = %{version}
Requires:  gtk2
Provides:  uim-applet-gtk
Provides:  uim-applet = %{version}

%description gtk
GNOME helper for uim. It contains some apps like toolbar, 
system tray, applet, candidate window for Uim library.

%package   qt
Summary:   KDE helper for uim
Group:     System/Internationalization
Requires:  %{name} = %{version}
Requires:  qt > 3.3.4-9mdk
Provides:  uim-applet = %{version}

%description qt
KDE helper for uim. It contains some apps like toolbar, 
system tray, applet, candidate window for Uim library.

%package   qtimmodule
Summary:   A plugin for using UIM on qt-immodule
Group:     System/Internationalization
Requires:  %{name} = %{version}
Requires:  qt > 3.3.4-9mdk

%description qtimmodule
A plugin for using UIM on qt-immodule.

%package -n %{libname}
Summary:    UIM library
Group:      System/Internationalization
Provides:   %{libname_orig} = %{version}-%{release}

%description -n %{libname}
UIM library.

%package -n %{libname}-devel
Summary:    Headers of uim for development
Group:      Development/C
Requires:   %{libname} = %{version}
Provides:   %{name}-devel = %{version}-%{release}
Provides:   %{libname_orig}-devel = %{version}-%{release}

%description -n %{libname}-devel
Headers of %{name} for development.


%prep
%setup -q

%build
[[ ! -x configure ]] && ./autogen.sh

# (gb) don't bother with making a proper patch at this time
perl -pi -e '/QTLIBDIR=.+\/lib/ and s,/lib,/%{_lib},' configure

%configure \
   --with-m17nlib \
   --without-canna \
   --without-prime \
   --without-scim \
   --without-eb \
%if %qtimmodule
   --with-qt-immodule \
%endif
   --with-qt

%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

# remove unnecessary devel files
rm -f %{buildroot}%{_libdir}/gtk-2.0/*/immodules/*.{a,la}

# remove unnecessary modules
rm -f %{buildroot}%{_datadir}/uim/{canna*,prime*,scim*,tutcode*}.scm

# remove config files.
# they should be generated by uim-module-manager.
rm -f %{buildroot}%{_datadir}/uim/{installed-modules,loader}.scm

%if %qtimmodule
mkdir -p %{buildroot}%{qtdir}/plugins/%{_lib}/inputmethods/
mv %{buildroot}/%{qtdir}/plugins/inputmethods/*.so %{buildroot}%{qtdir}/plugins/%{_lib}/inputmethods/
rm -rf %{buildroot}/%{qtdir}/plugins/inputmethods/
%endif

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT


%post
# remove old config files
rm -f %{_datadir}/uim/{installed-modules,loader}.scm
rm -f %{_datadir}/uim/modules

# register uim modules
uim-module-manager --register anthy m17nlib skk


%post gtk
gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules.%_lib

%postun gtk
gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules.%_lib

%post qtimmodule -p /sbin/ldconfig

%postun qtimmodule -p /sbin/ldconfig

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig


%files -f %{name}.lang
%defattr(-,root,root)
%doc AUTHORS COPYING README README.ja
%{_bindir}/uim-fep*
%{_bindir}/uim-helper-server
%{_bindir}/uim-module-manager
%{_bindir}/uim-sh
%{_bindir}/uim-xim
%{_datadir}/applications/*
%{_datadir}/man/man1/*
%{_datadir}/uim/*.scm
%{_datadir}/uim/helperdata/*
%{_datadir}/uim/pixmaps/*
%{_datadir}/uim/tables/*

%files gtk
%defattr(-,root,root)
%doc COPYING
%{_bindir}/uim-*-gtk*
%{_bindir}/uim-input-pad-ja
%{_libdir}/gtk-2.0/*/immodules/*.so

%files qt
%defattr(-,root,root)
%doc COPYING
%{_bindir}/uim-*-qt*

%if %qtimmodule
%files qtimmodule
%defattr(-,root,root)
%doc COPYING
%dir %{_prefix}/lib/qt3/plugins/%{_lib}/inputmethods/
%{_prefix}/lib/qt3/plugins/%{_lib}/inputmethods/*.so
%endif

%files -n %{libname}
%defattr(-,root,root)
%doc COPYING
%{_libdir}/lib*.so.*
%{_libdir}/bonobo/servers/*.server
%{_libdir}/uim/plugin/libuim-*.so
%{_libexecdir}/uim-helper-applet
%{_libexecdir}/uim-toolbar-applet

%files -n %{libname}-devel
%defattr(-,root,root)
%doc COPYING
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/lib*.a
%{_libdir}/lib*.la
%{_libdir}/pkgconfig/*.pc
%{_libdir}/uim/plugin/libuim-*.a
%{_libdir}/uim/plugin/libuim-*.la


%changelog
* Mon Sep 12 2005 Thierry Vignaud <tvignaud@mandriva.com> 0.4.8-4mdk
- rebuild b/c of qt-immodule (#18486)

* Thu Aug 25 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.4.8-3mdk
- fix location of qt plugins

* Wed Aug 17 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.8-2mdk
- rebuild against gcc-4.0.1
- (we need to build uim-qtimmodule and qt3 with the same gcc)
- merge module packages into uim (to maintain packages easily)
- change URL

* Mon Aug 08 2005 Thierry Vignaud <tvignaud@mandriva.com> 0.4.8-1mdk
- fix requires
- remove useless ldconfig in {post,pre} (for plugins not reachable by ld)
- misc other cleanup
- UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
  o new release
  o use uim-module-manager to (un)register plugins
  o remove "buildrequires kdelibs-devel"
  o (uim-qt/uim-qtimmodule don't need it)

* Wed Aug 03 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.7.1-1mdk
- new release
- enable uim-qtimmodule
- remove uim-prime (it needs many buildrequires)
- remove eb support to reduce buildrequires
- remove unnecessary files (canna*.scm, tutcode*.scm)
- fix requires for uim-qt (kdelibs -> qt)
- spec cleanup

* Mon May 09 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-7.svn0837.1mdk
- remove patch0,1 (merged upstream)
- latest snapshot

* Tue Mar 29 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-7.svn0811.1mdk
- add skkserv support (patch0,1)
- latest snapshot
- update source2,3,4 for prime-1.0.0.1
- add some comments for new packagers
- modify buildrequires

* Tue Mar 29 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.6-6mdk
- ensure either qt or gtk is installed with uim so that setup panel, helper
  toolbar etc... works (#14947)

* Tue Mar 22 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.6-5mdk
- fix upgrade (uim-applet is dead)

* Sat Mar 12 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.4.6-4mdk
- add BuildRequires: libanthy-devel, libncurses-devel

* Thu Mar 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.6-3mdk
- fix build on lib64 platforms
- fix buildrequires (again, titi watch out!)

* Wed Mar 02 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-2mdk
- update source2 for prime-0.9.4-rc1
- add obsoletes prime <= 0.9.4-0.alpha3.1mdk
- fix requires

* Mon Feb 28 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-1mdk
- new release (uim-0.4.6-final)
- replace prime.scm (source2)
- add uim-qtimmodule (default = disabled)

* Wed Feb 23 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-1.beta2.3mdk
- add source1 uim-update-imlist
- (uim doesn't update im engine list automatically)

* Tue Feb 22 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-1.beta2.2mdk
- split in several subpackages (uim-anthy, uim-m17n, uim-prime, uim-skk)

* Mon Feb 21 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.6-1.beta2.1mdk
- fix requires (rpmlint)
- new release (security fix) (UTUMI Hirosi <utuhiro78@yahoo.co.jp>)

* Fri Feb 18 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.6-0.svn0667.2mdk
- change buildrequires prime-dict to libprime
- add buildrequires kdelibs-devel (for uim-qt)
- add buildrequires libeb-devel (for electronic book support)
- remove "post qt" and "postun qt". uim-qt doesn't have libraries.

* Thu Feb 17 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.6-0.svn0667.1mdk
- fix buildrequires
- UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
  o latest snapshot (uim-0.4.6-alpha)
  o spec cleanup
  o add uim-gtk, uim-qt
  o uim-applet is merged into libuim0

* Wed Feb 16 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.5-5.20050113.3mdk
- fix requires

* Mon Jan 31 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.5-5.20050113.2mdk
- kill wrong buildrequires

* Thu Jan 13 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.5-5.20050113.1mdk
- latest snapshot
- add "Prereq:  gtk-query-immodules-2.0"
- remove prime.scm (It should be installed by prime. prime-x.y.z needs prime-x.y.z.scm.)

* Thu Dec 30 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.5-4mdk
- add patch0, patch1
- remove "--with-canna", "--enable-dict" (experimental)

* Sun Nov 14 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.5-3mdk
- new release
- add BuildRequires: canna-devel (another Japanese translation engine)
- add uim-dict (a tool for managing dictionary)

* Thu Oct 21 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.3-2mdk
- mklibname fixes
- no XFCE4 applet generated

* Sat Sep 04 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.3-1mdk
- new release

* Sat Jul 31 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.2.1-1mdk
- new release

* Thu Jul 29 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.2-1mdk
- new release
- fix build from official releases
- fix uim-fep build

* Thu Jul 29 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.1-3.svn1041.1mdk
- svn 1041

* Wed Jul 28 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.4.1-3.svn1029.1mdk
- svn 1029

* Wed Jul 28 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.1-2.svn0997.2mdk
- biarch support

* Tue Jul 20 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.4.1-2.svn0997.1mdk
- do not package useless files in doc
- UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
  o new release
  o svn 997

* Tue Jun 29 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.3.9-2.svn912.2mdk
- svn 912
- (source) svn checkout http://freedesktop.org:8080/svn/uim/trunk

* Mon Jun 14 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.9-1mdk
- new release
- remove patch 0 (merged upstream)

* Sun Jun 13 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 0.3.8-4mdk
- svn 899
- add patch0 (made by James - it will be merged)

* Tue Jun 08 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.8-3mdk
- rebuild for new g++

* Thu May 27 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.8-2mdk
- add m17n support (UTUMI Hirosi)

* Thu May 27 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.8-1mdk
- new release
- do not overwrite config files on update

* Thu Apr 08 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.4.2-2mdk
- fix duplicated buildrequires

* Wed Apr 07 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.4.2-1mdk
- new release
- fix buildrequires
- include download url in source0
- change summary and description (UTUMI Hirosi, by authors request)
- link with gtk+2.4.0 (because of new immodules path)

* Thu Apr 01 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.3.3-1mdk
- new release
- drop patches 0 and 1 (merged upstream)

* Fri Mar 19 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.8-5mdk
- Patch1: fix crash in nautilus

* Mon Mar 08 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.2.8-4mdk
- patch 0: fix numeric pad in KDE applications (transmitted by UTUMI Hirosi)

* Mon Feb 16 2004 Abel Cheung <deaddog@deaddog.org> 0.2.8-3mdk
- Sanitize spec file
- Fix post scripts
- Add missing requirement

* Sat Feb 14 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.2.8-2mdk
- build release

* Tue Feb 10 2004 Guillaume Cottenceau <gc@mandrakesoft.com> 0.2.8-1mdk
- new version

* Fri Jan 30 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.2.7-2mdk
- use proper build fix

* Thu Jan 29 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.2.7-1mdk
- new release
- fix build

* Wed Jan 21 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.2.4-1mdk
- fix group
- fix not localized messages catalog
- add ldconfig call
- fix unpackaged files
- kill useless requires guessed by rpm
- mklibname support
- initial upload based on UTUMI Hirosi <utuhiro78@yahoo.co.jp> work

* Sun Jan 11 2004 Yuhei Matsunaga <yuhei@users.sourceforge.jp> 0.2.4-1
- Version updated.
